1 Reply Latest reply on Oct 18, 2012 3:37 AM by Marco Trevisan

    Guvnor 5.3.1 and JBoss AS 5.1 w/CXF

    Marco Trevisan Newbie

      Hi all,

       

      After successfully installing drools-guvnor 5.3.1 (obtained using JBPM 5.2 demo installer ANT script) and running it, I installed jbossws-cxf 3.4.0.GA (the last version certified to work with JBoss AS 5.1 GA according to the table of compatibility).

       

      From that moment on, Guvnor's web services stopped working because of classloading issues related to incompatible versions of CXF (2.3.1 in jbossws-cxf-3.4.0 vs 2.4.1 in Guvnor). The exception arising is: java.lang.ClassCastException: class org.apache.cxf.transport.jms.wsdl.ReplyToNameType, when a service is invoked.

       

      If I remove the CXF jars from drools-guvnor's WEB-INF/lib folder, the deploy complains it can't find CXFServlet, so it does not sartup any web service. Also, the CXF version included in Guvnor 5.3.1 is more recent than that of jbossws-cxf-3.4.0. From a  user standpoint I expect it can be replaced by the version  shipped with AS 5.1 since Guvnor 5.3.1 is declared to be compatible with AS 5.1 (correct me if I'm wrong).

       

      If, instead of removing the JARs, I try to add a jboss-classloading.xml file like the following:

       

      <?xml version="1.0" encoding="UTF-8"?>
      <classloading xmlns="urn:jboss:classloading:1.0"
                    parent-first="false"
                    domain="DefaultDomain"
                    top-level-classloader="true"
                    parent-domain="Ignored"
                    export-all="NON_EMPTY"
                    import-all="true">
      </classloading>
      

       

      the deploy fails the same way as reported here: https://community.jboss.org/thread/155075, but geronimo-annotation-spec-1.1.1.jar is already in WEB-INF/lib.

      Maybe some other jars are missing in drools-guvnor's WEB-INF/lib in order to make it work correctly in such classloading mode.

       

      In conclusion, my questions:

       

      - is there a way to make Guvnor 5.3.1 work correctly in JBoss AS 5.1 GA when jbossws-cxf 3.4.0.GA installed?

      - is the above jboss-classloading.xml correct for the purpose of forcing classloading at webapp side first? I also tried some variants I found in the Jboss forums but they didn't work.

      - Is there a reasonably straightforward way to allow a webapp which runs perfectly under Tomcat 6.0.x to run on JBoss AS 5.1GA regardless of which JAR versions are in the server's lib?

       

      Thanks in advance,  regards.

       

      Marco